## EDU.oswego.cs.dl.util.concurrent
Class CopyOnWriteArrayList.COWSubList.COWSubListIterator

    java.lang.Object
      EDU.oswego.cs.dl.util.concurrent.CopyOnWriteArrayList.COWSubList.COWSubListIterator

All Implemented Interfaces:
  java.util.Iterator, java.util.ListIterator

Enclosing class:
  CopyOnWriteArrayList.COWSubList

    protected class CopyOnWriteArrayList.COWSubList.COWSubListIterator

extends java.lang.Object
implements java.util.ListIterator

Field Summary
`protected java.util.ListIterator` `i`
`protected int` `index`

Constructor Summary
`protected` `CopyOnWriteArrayList.COWSubList.COWSubListIterator(int index)`

Method Summary
`void` `add(java.lang.Object o)`
`boolean` `hasNext()`
`boolean` `hasPrevious()`
`java.lang.Object` `next()`
`int` `nextIndex()`
`java.lang.Object` `previous()`
`int` `previousIndex()`
`void` `remove()`
`void` `set(java.lang.Object o)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### i

    protected final java.util.ListIterator i

### index

    protected final int index

Constructor Detail

### CopyOnWriteArrayList.COWSubList.COWSubListIterator

    protected CopyOnWriteArrayList.COWSubList.COWSubListIterator(int index)

Method Detail

### hasNext

    public boolean hasNext()

  Specified by:
    `hasNext` in interface `java.util.Iterator`
  Specified by:
    `hasNext` in interface `java.util.ListIterator`

### next

    public java.lang.Object next()

  Specified by:
    `next` in interface `java.util.Iterator`
  Specified by:
    `next` in interface `java.util.ListIterator`

### hasPrevious

    public boolean hasPrevious()

  Specified by:
    `hasPrevious` in interface `java.util.ListIterator`

### previous

    public java.lang.Object previous()

  Specified by:
    `previous` in interface `java.util.ListIterator`

### nextIndex

    public int nextIndex()

  Specified by:
    `nextIndex` in interface `java.util.ListIterator`

### previousIndex

    public int previousIndex()

  Specified by:
    `previousIndex` in interface `java.util.ListIterator`

### remove

    public void remove()

  Specified by:
    `remove` in interface `java.util.Iterator`
  Specified by:
    `remove` in interface `java.util.ListIterator`

### set

    public void set(java.lang.Object o)

  Specified by:
    `set` in interface `java.util.ListIterator`

### add

    public void add(java.lang.Object o)

  Specified by:
    `add` in interface `java.util.ListIterator`